/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package site1;

import java.io.IOException;
import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author mudromar
 */
public class ServerThread implements Runnable {

    private ArrayList<Data> list;
    private Socket clientSocket;
    private Server2 server;

    public ServerThread(ArrayList<Data> list, Socket clientSocket, Server2 server) {
        this.list = list;
        this.clientSocket = clientSocket;
        this.server = server;
    }

    @Override
    public void run() {
        try {
            System.out.println("Pripojen klient");
            //nejaka cinnost
            InputStream is = clientSocket.getInputStream();
            BufferedReader br = new BufferedReader(new InputStreamReader(is));

            OutputStream os = clientSocket.getOutputStream();
            OutputStreamWriter osw = new OutputStreamWriter(os);

            int stage = 0;
            String helo = "";
            String IDText = "";
            String eventText = "";
            String entryText = "";

            while (stage != 100) {
                switch (stage) {
                    case 0:
                        helo = br.readLine();
                        if (helo.startsWith("HELO ")) {
                            System.out.println("Prijato HELO: " + helo.substring(5));
                            osw.write("OK\n");
                            osw.flush();
                            stage++;
                        } else if (helo.startsWith("KONECPROGRAMU")) {
                            ObjectOutputStream oos = new ObjectOutputStream(os);
                            System.out.println(list);
                            oos.writeObject(list);
                            server.stopServer();
                        } else {
                            stage = 100;
                        }
                        break;
                    case 1:
                        IDText = br.readLine();
                        if (IDText.startsWith("ID ")) {
                            System.out.println("Prijato ID: " + IDText.substring(3));
                            osw.write("OK\n");
                            osw.flush();
                            stage++;
                        } else {
                            stage = 100;
                        }
                        break;
                    case 2:
                        eventText = br.readLine();
                        if (eventText.startsWith("EVENT ")) {
                            System.out.println("Prijat EVENT: " + eventText.substring(6));
                            osw.write("OK\n");
                            osw.flush();
                            stage++;
                        } else {
                            stage = 100;
                        }
                        break;

                    case 3:
                        entryText = br.readLine();
                        if (entryText.startsWith("ENTRY")) {
                            System.out.println("Prijato ENTRY");
                            osw.write("OK\n");
                            synchronized (list) {
                                list.add(new Data(helo.substring(5), IDText.substring(3), eventText.substring(6), true));
                            }
                            osw.flush();
                        } else if (entryText.startsWith("EXIT")) {
                            System.out.println("Prijato EXIT");
                            osw.write("OK\n");
                            synchronized (list) {
                                list.add(new Data(helo.substring(5), IDText.substring(3), eventText.substring(6), false));
                            }
                            osw.flush();
                        }
                        stage = 100;
                        break;
                }
                System.out.println("stage = " + stage);
            }
            System.out.println("Cinnost probehla");

            osw.write("BYE\n");
            osw.flush();
            br.close();
            is.close();
            osw.close();
            os.close();
            synchronized (list) {
                System.out.println(list);
            }

        } catch (IOException e) {
            System.out.println("Pripojeni selhalo.");
            e.printStackTrace();
            System.exit(-1);
        } finally {
            try {
                clientSocket.close();
            } catch (IOException ex) {
                Logger.getLogger(ServerThread.class.getName()).log(Level.SEVERE, null, ex);
            }

        }
    }

}
